routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => 'language'], function () {
    Route::get('/', 'PhotosController@index')->name('mainpage');
    Route::resource('photos', 'PhotosController')->except('edit', 'update');
    Route::resource('users', 'UsersController')->except('index', 'create', 'store', 'destroy');
    Route::resource('photos.comments', 'CommentsController')->except('index', 'create')->middleware('auth');
    Auth::routes();
    Route::get('/home', 'HomeController@index')->name('home');
});

Route::get('language/{locale}', 'LanguageSwitcherController@switcher')
    ->name('language.switcher')
    ->where('locale', 'en|ru');

app/Photo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Orchid\Attachment\Attachable;
use Orchid\Filters\Filterable;
use Orchid\Screen\AsSource;

class Photo extends Model
{
    use AsSource, Attachable, Filterable;
    protected $fillable = ['caption', 'image', 'user_id'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments() {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/PhotosController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Http\Requests\PhotoRequest;
use App\Photo;
use App\User;
use Illuminate\Support\Facades\Auth;

class PhotosController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        $photos = Photo::select('id', 'user_id', 'caption', 'image', 'created_at', 'updated_at')
            ->latest()->paginate(8);
        return view('photos.index', compact('photos'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view('photos.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function store(PhotoRequest $request)
    {
        $validated = $request->validated();
        $user = Auth::user();
        $photo = new Photo();

        $data = $request->all();
        $file = $request->file('image');
        if (!is_null($file)) {
            $path = $file->store('images', 'public');
            $data['image'] = $path;
        }

        $photo->user_id = $request->user()->id;
        $data['user_id'] = $photo->user_id;

        $photo->create($data);

        return redirect()->route('users.show', ['user' => $user])->with('message', 'New photo added!');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $photo = Photo::findOrFail($id);
        $photo->setRelation('comments', $photo->comments()->latest()->paginate(3));
        $comments = Comment::all();
        $total_comments = $comments->count();
        $total_score = 0;
        foreach($comments as $comment) {
            $total_score += $comment->rate;
        }
        $average_score = round(($total_score / $total_comments), 2);
        return view('photos.show', compact('photo', 'comments', 'average_score'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Illuminate\Auth\Access\AuthorizationException
     */
    public function destroy($id)
    {
        $user = Auth::user();
        $photo = Photo::findOrFail($id);
        $this->authorize('delete', $photo);
        $photo->comments()->delete();
        $photo->delete();
        return redirect()->route('users.show', ['user' => $user])->with('message', 'Photo deleted!');
    }

}

resources/views/photos/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="col-6 mb-4 mt-5 offset-md-3">
            <h5>@lang('Add new photo'):</h5>
        </div>
        <div class="col-6 offset-md-3">
            <form method="post" action="{{route('photos.store')}}" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <div class="form-group row">
                        <label for="caption" class="col-sm-2 col-form-label">@lang('Caption')</label>
                        <div class="col-sm-10">
                            <input name="caption" class="form-control @error('caption') is-invalid @enderror"
                                   id="caption"/>
                            @error('caption')
                            <p class="error">{{ $message }}</p>
                            @enderror
                        </div>
                    </div>
                    <div class="form-group row">
                        <label for="image" class="col-sm-2 col-form-label">@lang('Image')</label>
                        <div class="col-sm-10">
                            <div class="custom-file">
                                <input type="file" class="custom-file-input  @error('image') is-invalid @enderror"
                                       id="customFile" name="image">
                                <label class="custom-file-label" for="customFile">@lang('Upload photo')</label>
                            </div>
                            @error('image')
                            <p class="error">{{ $message }}</p>
                            @enderror
                        </div>
                    </div>

                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">@lang('Create')</button>
                <a href="{{route('photos.index')}}">@lang('Back')</a>
            </form>
        </div>
    </div>
@endsection

resources/views/photos/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row d-flex justify-content-center">
            @foreach($photos as $photo)
                <div class="col-md-3 mt-4">
                    <div class="card ml-0 mr-0">
                        <img class="img-thumbnail"
                             src="{{asset('/storage/' . $photo->image)}}" alt="Photo"
                             style="width: 300px; height: 200px">
                        <div class="card-footer">
                            <div>
                                <p class="caption m-0" style="font-size: 15px;">
                                    <a href="{{route('photos.show', ['photo' =>$photo])}}">{{ $photo->caption }}</a>
                                </p>
                                <p class="mb-0">@lang('By'):
                                    <a href="{{route('users.show', ['user' =>$photo->user])}}"> {{$photo->user->name}}</a>
                                </p>
                            </div>
                        </div>
                    </div>
                </div>
            @endforeach
        </div>
        <div class="row p-5">
            <div class="col-10 offset-4">
                {{ $photos->links() }}
            </div>
        </div>
    </div>

@endsection

resources/views/photos/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        @if (session('message'))
            <div class="alert alert-primary" role="alert">
                {{ session('message') }}
            </div>
        @endif
        <div class="row">
            <div class="col-md-12">
                <h3 class="mb-2 mt-3">{{$photo->caption}}</h3>
                <img class="img-fluid" src="{{asset('/storage/' . $photo->image)}}" alt="Photo">
                <h5 class="mt-2">@lang('Average score'): {{$average_score}}</h5>
            </div>
        </div>

        <div class="row">
            <div class="col-md-12 mt-5">
                <h3>@lang('Add comment')</h3>
            </div>
        </div>

        <div class="row mt-4">
            <div class="col-7">
                @csrf
                @foreach($photo->comments as $comment)
                    <div class="media" id="delete-comment-{{$comment->id}}">
                        <img class="d-flex rounded-circle mt-0 mr-3" style="width: 50px; height: 50px"
                             src="{{asset('/images/default_photo.jpeg')}}" alt="Image">
                        <div class="media-body">
                            <div class="mb-3">
                                @can('delete', $comment)
                                    <form method="post"
                                          action="{{route('photos.comments.destroy', ['photo' => $photo, 'comment' => $comment])}}">
                                        @method('DELETE')
                                        @csrf
                                        <button type="submit" class="delete btn btn-light" aria-hidden="true"
                                                style="float: right"
                                        >&times;
                                        </button>
                                    </form>
                                @endcan
                            </div>
                            <div class="comment">
                                <p>@lang('By'): <b>{{$comment->user->name}}</b>,
                                    <span> @lang('score'): {{$comment->rate}}</span></p>
                            </div>
                            <p class="pr-4">{{$comment->body}}</p>
                            @can('update', $comment)
                                <a href="{{route('photos.comments.edit', ['photo' => $photo, 'comment' => $comment])}}"
                                   style="font-size: 12px">@lang('Edit')</a>
                            @endcan
                            <p class="created-at">@lang('Created') {{$comment->created_at->diffForHumans()}}</p>
                            <hr>
                        </div>
                    </div>
                @endforeach
            </div>
            <div class="col-md-4 ml-auto mt-3">
                <div class="comment-form">
                    <form method="post" action="{{route('photos.comments.store', ['photo' => $photo])}}">
                        @csrf
                        <div class="form-group">
                            <label for="body">@lang('Comment')</label>
                            <textarea name="body" class="form-control @error('body') is-invalid @enderror" id="body"
                                      id="body" rows="3"/></textarea>
                            @error('body')
                            <p class="error">{{$message}}</p>
                            @enderror
                        </div>
                        <div class="form-group">
                            <label for="rate">@lang('Score')</label>
                            <select name="rate" id="rate" class="form-control @error('rate') is-invalid @enderror"
                                    id="rate" required>
                                <option disabled selected>@lang('Choose score'):</option>
                                <option>1</option>
                                <option>2</option>
                                <option>3</option>
                                <option>4</option>
                                <option>5</option>
                            </select>
                            @error('rate')
                            <p class="error">{{$message}}</p>
                            @enderror
                        </div>
                        <button type="submit" class="btn btn-primary btn-block">@lang('Add comment')
                        </button>
                    </form>
                </div>
            </div>
        </div>
        <div class="row p-5">
            <div class="col-10 offset-5">
                {{$photo->comments->links()}}
            </div>
        </div>
    </div>
@endsection